# Josh's JSON Library

A bare-minimal, yet industrial-strength C++ 20 library for reading, writing, and serialization of JSON files.

![Static Badge](https://img.shields.io/badge/Lit-Based-%20)
![Static Badge](https://img.shields.io/badge/License-Public%20Domain-%20)
![Static Badge](https://img.shields.io/badge/Linux-Supported-%20?style=flat&logo=linux)
![Static Badge](https://img.shields.io/badge/Fedora-Supported-%20?style=flat&logo=fedora)
![Static Badge](https://img.shields.io/badge/Win10-Supported-%20?style=flat&logo=windows)

## Features

* Modern C++ (20)
* Simple, well-documented API.
* Included parsing, validation, and manipulation tool for the CLI.
* Static Library
* GCC and MSVC support
* Tested on Fedora Linux and Windows 10.

## API Overview

```cpp

tuple<value, string> parse(string);
string deparse(value, string whitespace = "");

struct json::value {...};
struct json::string {...};
struct json::number {...};
struct json::boolean {...};
struct json::object {...};
struct json::array {...};

```


## Contributing


## License
Developed by Josh O'Leary @ Redacted Software.

Special Thanks to William J Tomasine II & Maxine Hayes.

(C) 2024, A Redacted Software Product.

This work is dedicated to the public domain.

